- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnDoubleArrayData Class Reference

# OpenMaya - API module for common classes | FunctionSet classes

Search for all occurrences

## Detailed Description

double array function set for dependency node data.

MFnDoubleArrayData allows the creation and manipulation of MDoubleArray data objects for use in the dependency graph.

If a user written dependency node either accepts or produces MDoubleArrays, then this class is used to extract or create the data that comes from or goes to other dependency graph nodes. The MDataHandle::type method will return kDoubleArray when data of this type is present. To access it, the MDataHandle::data method is used to get an MObject for the data and this should then be used to initialize an instance of MFnDoubleArrayData.

Examples:

  clothPaintAttrCmd.cpp, particleAttrNode.cpp, and torusField.cpp.

`#include <MFnDoubleArrayData.h>`

Inheritance diagram for MFnDoubleArrayData:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnDoubleArrayData ()
| Destructor.
| MFnDoubleArrayData ()
| Default constructor.
| MFnDoubleArrayData (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
unsigned int | length (MStatus *ReturnStatus=NULL) const
| Return the number of doubles in the instance.
double | operator[] (unsigned int index) const
| Extract the indicated double from the const instance.
MStatus | set (double element, unsigned int index)
| Set the double array element at the specified index.
MStatus | copyTo (MDoubleArray &) const
| Copy all the doubles in the instance into the given MDoubleArray.
MStatus | set (const MDoubleArray &newArray)
| Set the instance to contain the doubles defined in the given MDoubleArray.
MDoubleArray | array (MStatus *ReturnStatus=NULL)
| Return an MDoubleArray containing the double array currently operated upon by the function set.
MObject | create (MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance, and initialize it to be empty.
MObject | create (const MDoubleArray &in, MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance, and initialize it to contain the data from the given MDoubleArray.
| MFnDoubleArrayData (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
double & | operator[] (unsigned int index)
| NO SCRIPT SUPPORT.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

MFnDoubleArrayData | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnDoubleArrayData | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kDoubleArrayData.

Reimplemented from MFnData.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnDoubleArrayData".

Reimplemented from MFnData.

unsigned int length | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the number of doubles in the instance.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  The number of doubles in the instance

double operator[] | ( | unsigned int | index | ) | const

Extract the indicated double from the const instance.

No checking is done by this class to ensure that the index is valid - use the length method to determine the size of the array. If the instance is not attached to an MObject, this method will return an double containing zero.

Parameters:

  [in] | index | the index of the double to extract

Returns:
  The indicated double

MStatus set | ( | double | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Set the double array element at the specified index.

The index must be valid for the array.

Parameters:

  [in] | element | the element to set at the specified index
  [in] | index | the index of the double to set

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

Examples:
  particleAttrNode.cpp.

MStatus copyTo | ( | MDoubleArray & | dest | ) | const

Search for all occurrences

Copy all the doubles in the instance into the given MDoubleArray.

Parameters:

  [out] | dest | the MDoubleArray to populate

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

MStatus set | ( | const MDoubleArray & | array | ) |

Search for all occurrences

Set the instance to contain the doubles defined in the given MDoubleArray.

Parameters:

  [in] | array | the MDoubleArray containing the data to set into this instance

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

MDoubleArray array | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return an MDoubleArray containing the double array currently operated upon by the function set.

The MDoubleArray returned by this method is editable, so any changes to the return instance also affects the MObject operated upon by this function set.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  A copy of the MDoubleArray held in this instance

Examples:
  particleAttrNode.cpp.

MObject create | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Create a new MObject, attach it to this instance, and initialize it to be empty.

Parameters:

  [out] | ReturnStatus | kSuccess g

Returns:
  The newly created MObject

MObject create | ( | const MDoubleArray & | arr,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Create a new MObject, attach it to this instance, and initialize it to contain the data from the given MDoubleArray.

Parameters:

  [in] | arr | the data to use when initializing this instance
  [out] | ReturnStatus | kSuccess

Returns:
  The newly created MObject

double & operator[] | ( | unsigned int | index | ) |

NO SCRIPT SUPPORT.

Extract the indicated double from the instance.

by the function set. The double returned by this method is editable, so any changes to the return instance also affects the MObject operated upon by this function set.

No checking is done by this class to ensure that the index is valid - use the length method to determine the size of the array. If the instance is not attached to an MObject, this method will return an double containing zero.

Parameters:

  [in] | index | the index of the double to extract

Returns:
  The indicated double

MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData
MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData MFnDoubleArrayData